new file mode 100755
@@ -0,0 +1,57 @@
+#!/bin/bash
+# FS QA Test No. btrfs/032
+#
+# Regression test for transaction abortion when remounting RW to RO
+# with flushoncommit option enabled.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2014 Fujitsu. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+
+_cleanup()
+{
+ rm -f $tmp.*
+}
+
+trap "_cleanup ; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+_require_scratch
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount "-o flushoncommit"
+
+$XFS_IO_PROG -f -c "pwrite 0 10M" "$SCRATCH_MNT/tmpfile" | _filter_xfs_io
+
+_scratch_mount "-o remount,ro"
+
+status=0 ; exit
new file mode 100644
@@ -0,0 +1,3 @@
+QA output created by 032
+wrote 10485760/10485760 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
@@ -34,3 +34,4 @@
029 auto quick
030 auto quick
031 auto quick
+032 auto quick
Btrfs would get a transaction abortion when remounting RW to RO with flushoncommit enabled.This test is to check if bug still exists. Signed-off-by: Wang Shilong <wangsl.fnst@cn.fujitsu.com> --- tests/btrfs/032 | 57 +++++++++++++++++++++++++++++++++++++++++++++++++++++ tests/btrfs/032.out | 3 +++ tests/btrfs/group | 1 + 3 files changed, 61 insertions(+) create mode 100755 tests/btrfs/032 create mode 100644 tests/btrfs/032.out